/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * welcome.java
 *
 * Created on Apr 4, 2013, 11:12:12 PM
 */
package grocerykart;

import java.awt.Desktop;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.ArrayList;

/**
 *
 * @author samicheen
 */
class GroceryKartSavedData {

    public ArrayList<Candidate> tmpCandidates;
    public ArrayList<Store> tmpStores;

    // New Methods added - Vehicle Analysis
    public GroceryKartSavedData() {
        tmpCandidates = new ArrayList<>();
        tmpStores = new ArrayList<>();
    }

    public int getTotalTrucks(Candidate solution) {
        return solution.routeTable.size();
    }

    public ArrayList<Integer> getTruckPath(Candidate solution, int truckNumber) {
        return solution.routeTable.get(truckNumber - 1).route;
    }

    public double getTruckDistance(Candidate solution, int truckNumber) {
        return solution.routeTable.get(truckNumber - 1).routeFitness;
    }

    public double getTruckDailyCost(Candidate solution, int truckNumber) {
        return solution.routeTable.get(truckNumber - 1).routeFitness * 30;
    }

    // Store Analysis
    public int getStoreDemand(int storeNumber) {
        return tmpStores.get(storeNumber - 1).demand;
    }

    public int getTruckFulfillStore(Candidate solution, int storeNumber) {
        int truckNumber = 0;
        outer:
        for (Route tmp : solution.routeTable) {
            truckNumber++;
            for (Integer store : tmp.route) {
                if (store == storeNumber) {
                    break outer;
                }
            }
        }
        return truckNumber;
    }
     public String getMaintenanceCost(Candidate solution, int months) {
        return 20000 * solution.routeTable.size() * months + "";
    }

    public String getVariableCost(Candidate solution, int days) {
        return Double.parseDouble(getTotalDistance(solution)) * 30 * days + "";
    }

    public String getTotalDistance(Candidate solution) {
        double distance = 0;
        for (Route tmp : solution.routeTable) {
            distance += tmp.routeFitness;
        }
        return distance + "";
    }

    public ArrayList<Candidate> readFromFile() {

        try {
            Candidate tmpCandidate;
            Store tmpStore;
            FileInputStream fin = new FileInputStream("solutions.kart");
            ObjectInputStream ois = new ObjectInputStream(fin);

            FileInputStream finstores = new FileInputStream("stores.kart");
            ObjectInputStream oisstores = new ObjectInputStream(finstores);
      
            int i=0;
            while(true) {
                i++;
                tmpCandidate = (Candidate) ois.readObject();
                tmpCandidates.add(tmpCandidate);
                if(i==10) break;
            }
            i=0;
            while(true) {
                i++; 
                tmpStore = (Store) oisstores.readObject();
                tmpStores.add(tmpStore);
                if(i==601) break;
            }
//            System.out.println(tmpCandidates.get(9));
//            System.out.println("----------------");
//            System.out.println(tmpStores.get(600));
            ois.close();

            return tmpCandidates;

        } catch (Exception ex) {
            ex.printStackTrace();
            return null;
        }
    }

//    public void proceed() {
////        GroceryKartSavedData g = new GroceryKartSavedData();
////        System.out.println("Truck Number : 3 , Path Below");
////        ArrayList<Integer> truckPath = g.getTruckPath(g.currentCandidates.get(0), 3);
////        System.out.println(truckPath);
////        System.out.println(g.getTruckDistance(g.currentCandidates.get(0), 3));
////        System.out.println("");
////        System.out.println("Store 200 : ");
////        System.out.println("Demand : " + g.getStoreDemand(200));
////        System.out.println("Fulfilled by : " + g.getTruckFulfillStore(g.currentCandidates.get(0), 200));
//    }
}

public class welcome extends javax.swing.JFrame {

    /**
     * Creates new form welcome
     */
    public welcome() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel1.setFont(new java.awt.Font("Times New Roman", 1, 18)); // NOI18N
        jLabel1.setText("GroceryKart");

        jLabel2.setFont(new java.awt.Font("Times New Roman", 0, 14)); // NOI18N
        jLabel2.setText("Select from following:");

        jButton1.setText("Route Evaluation");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText("Best Available Routes");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setText("Trucks Analysis");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jButton4.setText("Stores Analysis");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jButton5.setText("Report Generation");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(173, 173, 173)
                        .addComponent(jLabel1))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(19, 19, 19)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel2)
                            .addComponent(jButton2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jButton1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jButton3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jButton4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jButton5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                .addContainerGap(128, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel2)
                .addGap(18, 18, 18)
                .addComponent(jButton1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButton2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButton3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButton4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButton5)
                .addContainerGap(67, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // TODO add your handling code here:
        bestroutes b = new bestroutes();
        b.main();
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:
        GroceryKartForm o = new GroceryKartForm();
        o.main();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // TODO add your handling code here:
        TrucksAnalysis t = new TrucksAnalysis();
        t.main();
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        // TODO add your handling code here:
        StoreAnalysis s = new StoreAnalysis();
        s.main();
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        // TODO add your handling code here:
         ReportGeneration r = new ReportGeneration();
        r.main();
        File file = new File("Report.pdf");
        try{
            Desktop.getDesktop().open(file);
            }
            catch(IOException e)
            {
                
            }
    }//GEN-LAST:event_jButton5ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main() {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new welcome().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    // End of variables declaration//GEN-END:variables
}
